<?

/*
php_vdr
script per pilotare la tua VDR box

@AUTHOR pclabs <peppe@pc-labs.org>
*/

/* parametri */
$vdr_ip = ''; // Indirizzo IP della VDR-box
$username = ''; // Nome utente per l'accesso SSH
$passwd = ''; // Password
/* --------- */

	include_once("svdrp.class.php");
	if (!isset($_GET['c'])) $c='index';
	else $c=$_GET['c'];

	$a = new SVDRP($vdr_ip);
	$a->Connect();

	switch($c)
	{
		case 'canale':
		$a->SwitchChannel($_GET['num']);
		break;

		case 'chup':
		$a->SwitchUp();
		break;

		case 'chdown':
		$a->SwitchDown();
		break;

		case 'spegni':
		inviaComando("halt");
		break;

		
	}

	echo '
<link href="default.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="funzioni.js"></script>
<script language="JavaScript" type="text/javascript" src="xmlhttp.js"></script>
<script type="text/javascript">var maxCanali = 0;</script>
';
	echo "\n\n<div id=boxStato></div>";
	echo "<a href=?c=spegni>Spegni</a><br><br>\n\n";
	echo "<a href=?c=chdown><<</a>  <a href=index.php>INDEX</a>  <a href=?c=chup>>></a><br><br>\n\n";
	echo "<div class=\"clear\"><!-- --></div>";

	$p_file = fopen("./channels.conf","r");
	$primo=true;
	$c_id=1;
	$g_id=0;
	$canali=array();
	while(!feof($p_file))
	{
		$linea = rtrim(fgets($p_file, 255));
		if (substr($linea, 0, 1) == ':')
		{
			if (!$primo) echo "</div></fieldset>\n";
			echo "<fieldset><legend>".substr($linea, 1)."</legend>\n";
			echo "<div style=\"float: right; \"><input type=button onclick=\"visualizza(".$g_id.");\" value=\"visualizza/nascondi\"></div><div class=\"clear\"><!-- --></div>";
			echo "<div id=g".$g_id." style=\"display: none;\">";
			$primo=false;
			$g_id++;
		}
		else		
		{
			$canale = explode(';', $linea);
			echo "<input id=c".$c_id." type=button onclick=\"cambiaCanale($c_id, '".$canale[0]."', maxCanali)\" value=\"$c_id - ".$canale[0]."\">";
			$c_id++;
		}
	}
	fclose($p_file);
	echo "</div></fieldset>\n";
echo '<script type="text/javascript">maxCanali = '.($c_id - 1).';</script>';

	
	$a->Disconnect();

function inviaComando($comando)
{
	$testo='';

	if (!function_exists("ssh2_connect")) die("function ssh2_connect doesn't exist");

	if(!($con = ssh2_connect($vdr_ip, 22))){
	    $testo.= "fail: unable to establish connection\n";
	} else {

	    if(!ssh2_auth_password($con, $username, $passwd)) {
		$testo.= "fail: unable to authenticate\n";
	    } else {

		$testo.= "okay: logged in...\n";
		

		if(!($shell = ssh2_shell($con, 'vt102', null, 80, 40, SSH2_TERM_UNIT_CHARS))){
		    $testo.= "fail: unable to establish shell\n";
		} else{
		    stream_set_blocking( $shell, true );

		    fwrite($shell,$comando."; exit;\n");
		    sleep(1);
		    

		    $data = "";
		    while( $buf = fread($shell,4096) ){
		        $data .= $buf;
		    }
		    fclose($shell);
		}
	    }
	}

return $testo;
}
?>

